----------------------------------------------------------------------------------
--  
--        cic.vhd        Ri@P^TPQ@bhbtB^[
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃ
--  ƓIp͂߂B
--
--20100111
-- Number of Slices:                      539  out of   2448    22%  
-- Number of Slice Flip Flops:            902  out of   4896    18%  
-- Number of 4 input LUTs:                583  out of   4896    11%  
-- Number of IOs:                          86
-- Number of bonded IOBs:                  75  out of     66   113% (*) 
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 5.243ns (Maximum Frequency: 190.714MHz)
--   Minimum input arrival time before clock: 5.564ns
--   Maximum output required time after clock: 4.825ns
--   Maximum combinational path delay: No path found
--


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity cic is 
  port (
    RESET   : in  std_logic;
    CLK     : in  std_logic;                      -- clock = 80MHz
--    MCE     : in  std_logic;                      -- Module Chip Enable
--    MWE     : in  std_logic;                      -- Module Write Enable
--    MADR    : in  std_logic;                      -- W[AhX
--    MWDATA  : in  std_logic_vector( 7 downto 0 ); -- W[֏ރf[^
    
    DATA_I_IN  : in  std_logic_vector( 17 downto 0); -- h̓f[^
    DATA_Q_IN  : in  std_logic_vector( 17 downto 0); -- p̓f[^
    DATA_I_OUT : out std_logic_vector( 17 downto 0); -- ho̓f[^
    DATA_Q_OUT : out std_logic_vector( 17 downto 0); -- po̓f[^
    WEN        : out std_logic                       -- o̓f[^݃^C~O
  );
end cic;


------------------------------------------------------------------------------
architecture RTL of cic is
  
--  component cic_3_512
--  component cic_3_2048
  component cic_3_4096
--  component cic_3_8192
    port (
      CICR_RESET   : in  std_logic;
      CICR_CLK     : in  std_logic;
      CICR_DATAIN  : in  std_logic_vector( 17 downto 0); -- ̓f[^
      CICR_WEN     : out std_logic;                      -- o̓f[^݃^C~O
      CICR_DATAOUT : out std_logic_vector( 17 downto 0)  -- o̓f[^
    );
  end component;
  
  begin
    
--    CIC_I_0 : cic_3_512
--    CIC_I_0 : cic_3_2048
    CIC_I_0 : cic_3_4096
--    CIC_I_0 : cic_3_8192
      port map (
        CICR_RESET   => RESET,
        CICR_CLK     => CLK,
        CICR_DATAIN  => DATA_I_IN,
        CICR_WEN     => WEN,
        CICR_DATAOUT => DATA_I_OUT
      );
    
--    CIC_Q_0 : cic_3_512
--    CIC_Q_0 : cic_3_2048
    CIC_Q_0 : cic_3_4096
--    CIC_Q_0 : cic_3_8192
      port map (
        CICR_RESET   => RESET,
        CICR_CLK     => CLK,
        CICR_DATAIN  => DATA_Q_IN,
        CICR_WEN     => open,
        CICR_DATAOUT => DATA_Q_OUT
      );
    
    
  end RTL;
----------------------------- end of architecture ----------------------------

