----------------------------------------------------------------------------------
--  
--        deltasigma_da.vhd         D/A ϊ
--  
--        (c)2011/03/29  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃǂ
--  ƓIp͂߂B
--
--
--Selected Device : 3s200avq100-4 
--
-- Number of Slices:                       17  out of   1792     0%  
-- Number of Slice Flip Flops:             33  out of   3584     0%  
-- Number of 4 input LUTs:                 34  out of   3584     0%  
-- Number of IOs:                          19
-- Number of bonded IOBs:                  19  out of     68    27%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 5.020ns (Maximum Frequency: 199.203MHz)
--   Minimum input arrival time before clock: 4.698ns
--   Maximum output required time after clock: 5.531ns
--   Maximum combinational path delay: No path found
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

------------------------------------------------------------------------------
entity deltasigma_da is
  port (
    RESET     : in  std_logic;                    -- 
    CLK       : in  std_logic;                    -- 
    
    DAIN      : in  std_logic_vector(15 downto 0);-- M
    
    DAOUT     : out std_logic                     -- Mo
  );
end deltasigma_da;

------------------------------------------------------------------------------
architecture RTL of deltasigma_da is
  
  signal DAIN0  : std_logic_vector(16 downto 0);  -- ϕ
  signal INTG   : std_logic_vector(16 downto 0);  -- ϕ
  signal DIFF   : std_logic_vector(15 downto 0);  -- 
  signal DAOUT0 : std_logic;  -- AD ϊo
  
  
begin
  
  DAIN0 <= DAIN(15)&DAIN;
  
  ------------------------------------------------------------------
  --    
  ------------------------------------------------------------------
  process( RESET, CLK ) begin
    if( RESET ='1') then
      INTG <= (others => '0');
      DIFF <= (others => '0');
    elsif( rising_edge(CLK) ) then
      if( INTG(16)='0' ) then
        INTG <= INTG + DAIN0 + "11000000000000000";
        DAOUT <= '1';
      else
        INTG <= INTG + DAIN0 + "00111111111111111";
        DAOUT <= '0';
      end if;
    end if;
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------
